`timescale 1ns/1ps

module ip_gddr71tx
(   input           refclk
,   input           sclk
,   input           reset
,   input  [6:0]    data0
,   input  [6:0]    data1
,   input  [6:0]    data2
,   input  [6:0]    data3
,   output          clkout_p
,   output          clkout_n
,   output [3:0]    dout_p
,   output [3:0]    dout_n
)/* synthesis syn_noprune=1 *//* synthesis NGD_DRC_MASK=1 */;


wire buf_douto3;
wire buf_douto2;
wire buf_douto1;
wire buf_douto0;
wire eclko;


reg  scuba_vhi;
reg  scuba_vlo;
always@(posedge reset or posedge sclk) begin
    if (reset)
        {scuba_vhi, scuba_vlo} <= 2'b00;
    else
        {scuba_vhi, scuba_vlo} <= 2'b10;
end


DHCEN dhcen_inst (.CLKIN(refclk), .CE(reset), .CLKOUT(eclko));// INV INV_0 (.I(preamble1), .O(preamble1_inv));


OVIDEO u_ODDR71_C (
    .PCLK(sclk), .FCLK(eclko), .RESET(reset), .D6(scuba_vhi), 
    .D5(scuba_vhi), .D4(scuba_vlo), .D3(scuba_vlo), .D2(scuba_vlo), 
    .D1(scuba_vhi), .D0(scuba_vhi), .Q(buf_clkout));

OVIDEO u_ODDR71_B3 (
    .PCLK(sclk), .FCLK(eclko), .RESET(reset), .D6(data3[6]), .D5(data3[5]),
    .D4(data3[4]), .D3(data3[3]), .D2(data3[2]), .D1(data3[1]), .D0(data3[0]), 
    .Q(buf_douto3));

OVIDEO u_ODDR71_B2 (
    .PCLK(sclk), .FCLK(eclko), .RESET(reset), .D6(data2[6]), .D5(data2[5]),
    .D4(data2[4]), .D3(data2[3]), .D2(data2[2]), .D1(data2[1]), .D0(data2[0]), 
    .Q(buf_douto2));

OVIDEO u_ODDR71_B1 (
    .PCLK(sclk), .FCLK(eclko), .RESET(reset), .D6(data1[6]), .D5(data1[5]),
    .D4(data1[4]), .D3(data1[3]), .D2(data1[2]), .D1(data1[1]), .D0(data1[0]), 
    .Q(buf_douto1));

OVIDEO u_ODDR71_B0 (
    .PCLK(sclk), .FCLK(eclko), .RESET(reset), .D6(data0[6]), .D5(data0[5]),
    .D4(data0[4]), .D3(data0[3]), .D2(data0[2]), .D1(data0[1]), .D0(data0[0]), 
    .Q(buf_douto0));



// wire buf_clkout;
// wire        buf_clkout_delay;
// wire        buf_douto0_delay;
// wire        buf_douto1_delay;
// wire        buf_douto2_delay;
// wire        buf_douto3_delay;
// wire [4:0]  buf_df_nc       ;

// IODELAY #(.C_STATIC_DLY(60)) u_IODELAY_d  (
//         .DF(buf_df_nc[4]),.DO(buf_clkout_delay),.DI(buf_clkout),.SDTAP(1'b0),.SETN(1'b0),.VALUE(1'b0));//defparam u_IODELAY_d.C_STATIC_DLY=60;

// IODELAY #(.C_STATIC_DLY(60)) u_IODELAY_d3 (
//         .DF(buf_df_nc[3]),.DO(buf_douto3_delay),.DI(buf_douto3),.SDTAP(1'b0),.SETN(1'b0),.VALUE(1'b0));//defparam u_IODELAY_d3.C_STATIC_DLY=60;

// IODELAY #(.C_STATIC_DLY(60)) u_IODELAY_d2 (
//         .DF(buf_df_nc[2]),.DO(buf_douto2_delay),.DI(buf_douto2),.SDTAP(1'b0),.SETN(1'b0),.VALUE(1'b0));//defparam u_IODELAY_d2.C_STATIC_DLY=60;

// IODELAY #(.C_STATIC_DLY(60)) u_IODELAY_d1 (
//         .DF(buf_df_nc[1]),.DO(buf_douto1_delay),.DI(buf_douto1),.SDTAP(1'b0),.SETN(1'b0),.VALUE(1'b0));//defparam u_IODELAY_d1.C_STATIC_DLY=60;

// IODELAY #(.C_STATIC_DLY(60)) u_IODELAY_d0 (
//         .DF(buf_df_nc[0]),.DO(buf_douto0_delay),.DI(buf_douto0),.SDTAP(1'b0),.SETN(1'b0),.VALUE(1'b0));//defparam u_IODELAY_d0.C_STATIC_DLY=60;


//assign clkout_p = buf_clkout;
//assign dout_p[3] = buf_douto3;
//assign dout_p[2] = buf_douto2;
//assign dout_p[1] = buf_douto1;
//assign dout_p[0] = buf_douto0;

// assign clkout_p  = buf_clkout_delay;
// assign dout_p[3] = buf_douto3_delay;
// assign dout_p[2] = buf_douto2_delay;
// assign dout_p[1] = buf_douto1_delay;
// assign dout_p[0] = buf_douto0_delay;

// defparam Inst2_CLKDIVF.DIV_MODE = "3.5" ;
// CLKDIV Inst2_CLKDIVF (.HCLKIN(eclko), .RESETN(~reset), .CALIB(scuba_vlo), 
    // .CLKOUT(sclk_t));
	
// assign  sclk_t = sclk;

// TLVDS_OBUF Inst7_OB (.O(clkout_p), .OB(clkout_n), .I(buf_clkout_delay));
// TLVDS_OBUF Inst3_OB3 (.O(dout_p[3]), .OB(dout_n[3]), .I(buf_douto3_delay));
// TLVDS_OBUF Inst3_OB2 (.O(dout_p[2]), .OB(dout_n[2]), .I(buf_douto2_delay));
// TLVDS_OBUF Inst3_OB1 (.O(dout_p[1]), .OB(dout_n[1]), .I(buf_douto1_delay));
// TLVDS_OBUF Inst3_OB0 (.O(dout_p[0]), .OB(dout_n[0]), .I(buf_douto0_delay));

TLVDS_OBUF u_tlvds_oc (.O(clkout_p) , .OB(clkout_n) , .I(buf_clkout));
TLVDS_OBUF u_tlvds_o3 (.O(dout_p[3]), .OB(dout_n[3]), .I(buf_douto3));
TLVDS_OBUF u_tlvds_o2 (.O(dout_p[2]), .OB(dout_n[2]), .I(buf_douto2));
TLVDS_OBUF u_tlvds_o1 (.O(dout_p[1]), .OB(dout_n[1]), .I(buf_douto1));
TLVDS_OBUF u_tlvds_o0 (.O(dout_p[0]), .OB(dout_n[0]), .I(buf_douto0));


endmodule
