module gw_gao(
    b2p_hsync,
    b2p_vsync,
    \b2p_pixel[23] ,
    \b2p_pixel[22] ,
    \b2p_pixel[21] ,
    \b2p_pixel[20] ,
    \b2p_pixel[19] ,
    \b2p_pixel[18] ,
    \b2p_pixel[17] ,
    \b2p_pixel[16] ,
    \b2p_pixel[15] ,
    \b2p_pixel[14] ,
    \b2p_pixel[13] ,
    \b2p_pixel[12] ,
    \b2p_pixel[11] ,
    \b2p_pixel[10] ,
    \b2p_pixel[9] ,
    \b2p_pixel[8] ,
    \b2p_pixel[7] ,
    \b2p_pixel[6] ,
    \b2p_pixel[5] ,
    \b2p_pixel[4] ,
    \b2p_pixel[3] ,
    \b2p_pixel[2] ,
    \b2p_pixel[1] ,
    \b2p_pixel[0] ,
    b2p_de,
    pixel_clk,
    tms_pad_i,
    tck_pad_i,
    tdi_pad_i,
    tdo_pad_o
);

input b2p_hsync;
input b2p_vsync;
input \b2p_pixel[23] ;
input \b2p_pixel[22] ;
input \b2p_pixel[21] ;
input \b2p_pixel[20] ;
input \b2p_pixel[19] ;
input \b2p_pixel[18] ;
input \b2p_pixel[17] ;
input \b2p_pixel[16] ;
input \b2p_pixel[15] ;
input \b2p_pixel[14] ;
input \b2p_pixel[13] ;
input \b2p_pixel[12] ;
input \b2p_pixel[11] ;
input \b2p_pixel[10] ;
input \b2p_pixel[9] ;
input \b2p_pixel[8] ;
input \b2p_pixel[7] ;
input \b2p_pixel[6] ;
input \b2p_pixel[5] ;
input \b2p_pixel[4] ;
input \b2p_pixel[3] ;
input \b2p_pixel[2] ;
input \b2p_pixel[1] ;
input \b2p_pixel[0] ;
input b2p_de;
input pixel_clk;
input tms_pad_i;
input tck_pad_i;
input tdi_pad_i;
output tdo_pad_o;

wire b2p_hsync;
wire b2p_vsync;
wire \b2p_pixel[23] ;
wire \b2p_pixel[22] ;
wire \b2p_pixel[21] ;
wire \b2p_pixel[20] ;
wire \b2p_pixel[19] ;
wire \b2p_pixel[18] ;
wire \b2p_pixel[17] ;
wire \b2p_pixel[16] ;
wire \b2p_pixel[15] ;
wire \b2p_pixel[14] ;
wire \b2p_pixel[13] ;
wire \b2p_pixel[12] ;
wire \b2p_pixel[11] ;
wire \b2p_pixel[10] ;
wire \b2p_pixel[9] ;
wire \b2p_pixel[8] ;
wire \b2p_pixel[7] ;
wire \b2p_pixel[6] ;
wire \b2p_pixel[5] ;
wire \b2p_pixel[4] ;
wire \b2p_pixel[3] ;
wire \b2p_pixel[2] ;
wire \b2p_pixel[1] ;
wire \b2p_pixel[0] ;
wire b2p_de;
wire pixel_clk;
wire tms_pad_i;
wire tck_pad_i;
wire tdi_pad_i;
wire tdo_pad_o;
wire tms_i_c;
wire tck_i_c;
wire tdi_i_c;
wire tdo_o_c;
wire [9:0] control0;
wire gao_jtag_tck;
wire gao_jtag_reset;
wire run_test_idle_er1;
wire run_test_idle_er2;
wire shift_dr_capture_dr;
wire update_dr;
wire pause_dr;
wire enable_er1;
wire enable_er2;
wire gao_jtag_tdi;
wire tdo_er1;

IBUF tms_ibuf (
    .I(tms_pad_i),
    .O(tms_i_c)
);

IBUF tck_ibuf (
    .I(tck_pad_i),
    .O(tck_i_c)
);

IBUF tdi_ibuf (
    .I(tdi_pad_i),
    .O(tdi_i_c)
);

OBUF tdo_obuf (
    .I(tdo_o_c),
    .O(tdo_pad_o)
);

GW_JTAG  u_gw_jtag(
    .tms_pad_i(tms_i_c),
    .tck_pad_i(tck_i_c),
    .tdi_pad_i(tdi_i_c),
    .tdo_pad_o(tdo_o_c),
    .tck_o(gao_jtag_tck),
    .test_logic_reset_o(gao_jtag_reset),
    .run_test_idle_er1_o(run_test_idle_er1),
    .run_test_idle_er2_o(run_test_idle_er2),
    .shift_dr_capture_dr_o(shift_dr_capture_dr),
    .update_dr_o(update_dr),
    .pause_dr_o(pause_dr),
    .enable_er1_o(enable_er1),
    .enable_er2_o(enable_er2),
    .tdi_o(gao_jtag_tdi),
    .tdo_er1_i(tdo_er1),
    .tdo_er2_i(1'b0)
);

gw_con_top  u_icon_top(
    .tck_i(gao_jtag_tck),
    .tdi_i(gao_jtag_tdi),
    .tdo_o(tdo_er1),
    .rst_i(gao_jtag_reset),
    .control0(control0[9:0]),
    .enable_i(enable_er1),
    .shift_dr_capture_dr_i(shift_dr_capture_dr),
    .update_dr_i(update_dr)
);

ao_top_0  u_la0_top(
    .control(control0[9:0]),
    .trig0_i(b2p_hsync),
    .trig1_i(b2p_vsync),
    .data_i({b2p_hsync,b2p_vsync,\b2p_pixel[23] ,\b2p_pixel[22] ,\b2p_pixel[21] ,\b2p_pixel[20] ,\b2p_pixel[19] ,\b2p_pixel[18] ,\b2p_pixel[17] ,\b2p_pixel[16] ,\b2p_pixel[15] ,\b2p_pixel[14] ,\b2p_pixel[13] ,\b2p_pixel[12] ,\b2p_pixel[11] ,\b2p_pixel[10] ,\b2p_pixel[9] ,\b2p_pixel[8] ,\b2p_pixel[7] ,\b2p_pixel[6] ,\b2p_pixel[5] ,\b2p_pixel[4] ,\b2p_pixel[3] ,\b2p_pixel[2] ,\b2p_pixel[1] ,\b2p_pixel[0] ,b2p_de}),
    .clk_i(pixel_clk)
);

endmodule
