## part 1: new lib

quit -sim

vlib work
vmap work work

## part 2: load design
vlog +define+SIM=1 "../../fpga_proj/src/top.v"
vlog +define+SIM=1 "../../fpga_proj/src/dpi_extractor.v"
vlog +define+SIM=1 "../../fpga_proj/src/byte_to_pixel/byte_to_pixel.vo"
vlog +define+SIM=1 "../../fpga_proj/src/dsi_rx/dsi_rx_top.vo"
vlog +define+SIM=1 "../../fpga_proj/src/gowin_mipi_dphy/gowin_mipi_dphy.v"
vlog +define+SIM=1 "../../fpga_proj/src/gowin_pll/gowin_pll_in_50m.v"
vlog +define+SIM=1 "../../fpga_proj/src/gowin_pll/gowin_pll_in_105m.v"
vlog +define+SIM=1 "../../fpga_proj/src/lvds_tx/ip_gddr71tx.v"
vlog +define+SIM=1 "../../fpga_proj/src/lvds_tx/lvds_7_to_1_tx.v"
#lib
vlog "../../tb/prim_sim.v"
vlog "../../tb/GW5A_25_MIPI_DPHY_top_sim.v"
vlog "../../tb/GW5A_25_MIPI_DPHY_modelsim.vp"
#testbench
vlog +define+SIM=1 "../../tb/tb_dsi2lvds.v"

## part 3: sim design
vsim +nowarnTFMPC -L work -voptargs=+acc work.tb_dsi2lvds

## part 4: add signals
do ./wave.do

## part 5: show ui 
view wave

## part 6: run 
# run -all
run 500us
