module MIPI_DPHY_RX (D0LN_HSRXD, D1LN_HSRXD, D2LN_HSRXD, D3LN_HSRXD, D0LN_HSRXD_VLD, D1LN_HSRXD_VLD, D2LN_HSRXD_VLD, 
  D3LN_HSRXD_VLD, D0LN_DESKEW_DONE, D1LN_DESKEW_DONE, D2LN_DESKEW_DONE, D3LN_DESKEW_DONE, DI_LPRX0_N, DI_LPRX0_P, 
  DI_LPRX1_N, DI_LPRX1_P, DI_LPRX2_N, DI_LPRX2_P, DI_LPRX3_N, DI_LPRX3_P, DI_LPRXCK_N, DI_LPRXCK_P, RX_CLK_O, 
  DESKEW_ERROR, CK_N, CK_P, RX0_N, RX0_P, RX1_N, RX1_P, RX2_N, RX2_P, RX3_N, RX3_P, LPRX_EN_CK, LPRX_EN_D0, LPRX_EN_D1, 
  LPRX_EN_D2, LPRX_EN_D3, HSRX_ODTEN_CK, HSRX_ODTEN_D0,  HSRX_ODTEN_D1, HSRX_ODTEN_D2, HSRX_ODTEN_D3, D0LN_HSRX_DREN,  
  D1LN_HSRX_DREN, D2LN_HSRX_DREN, D3LN_HSRX_DREN, HSRX_EN_CK, DESKEW_REQ, HS_8BIT_MODE, RX_CLK_1X, RX_INVERT, 
  LALIGN_EN, WALIGN_BY, DO_LPTX0_N, DO_LPTX0_P, DO_LPTX1_N, DO_LPTX1_P, DO_LPTX2_N, DO_LPTX2_P, DO_LPTX3_N, DO_LPTX3_P,
  DO_LPTXCK_N, DO_LPTXCK_P, LPTX_EN_CK, LPTX_EN_D0, LPTX_EN_D1, LPTX_EN_D2, LPTX_EN_D3, BYTE_LENDIAN, HSRX_STOP, PWRON, 
  RESET, DESKEW_BY,DESKEW_EN_OEDGE, DESKEW_HALF_OPENING, DESKEW_LSB_MODE, DESKEW_LNSEL, DESKEW_MTH, DESKEW_M, 
  DESKEW_MSET, DESKEW_OCLKEDG_EN, DESKEW_OWVAL, DRST_N, ONE_BYTE0_MATCH, WORD_LENDIAN, FIFO_RD_STD, EQCS_LANE0, 
  EQCS_LANE1, EQCS_LANE2, EQCS_LANE3, EQCS_CK, EQRS_LANE0, EQRS_LANE1, EQRS_LANE2, EQRS_LANE3, EQRS_CK,
  HSRX_DLYDIR_LANE0, HSRX_DLYDIR_LANE1, HSRX_DLYDIR_LANE2, HSRX_DLYDIR_LANE3, HSRX_DLYDIR_CK, HSRX_DLYLDN_LANE0, 
  HSRX_DLYLDN_LANE1, HSRX_DLYLDN_LANE2, HSRX_DLYLDN_LANE3, HSRX_DLYLDN_CK, HSRX_DLYMV_LANE0, HSRX_DLYMV_LANE1, 
  HSRX_DLYMV_LANE2, HSRX_DLYMV_LANE3, HSRX_DLYMV_CK, WALIGN_DVLD);

  output D0LN_DESKEW_DONE,D1LN_DESKEW_DONE,D2LN_DESKEW_DONE,D3LN_DESKEW_DONE;
  
  output [15:0] D0LN_HSRXD, D1LN_HSRXD, D2LN_HSRXD, D3LN_HSRXD;//data lane HS data output to fabric     
  output D0LN_HSRXD_VLD,D1LN_HSRXD_VLD,D2LN_HSRXD_VLD,D3LN_HSRXD_VLD;//data lane HS data output valid to fabric
  output DI_LPRX0_N, DI_LPRX0_P, DI_LPRX1_N, DI_LPRX1_P, DI_LPRX2_N, DI_LPRX2_P, DI_LPRX3_N, DI_LPRX3_P;//Data Lane Complement/True Pad LPRX input
  output DI_LPRXCK_N, DI_LPRXCK_P;
  output RX_CLK_O;          //HSRX Clock output 
  output DESKEW_ERROR;      //4 data lane deskew result error report
  
  inout  CK_N, CK_P, RX0_N, RX0_P, RX1_N, RX1_P, RX2_N, RX2_P, RX3_N, RX3_P;
  
  
  input BYTE_LENDIAN;       //bit data Littlendian/Bigendian of 8bit
  input [2:0] FIFO_RD_STD;  //FIFO read threadhold; Can only be 1 in 8bit mode.
  input HSRX_STOP;          //HSRX Clock Stop Signal for synchronization
  input PWRON;              //PowerOn Control: 1'b1: HSRX on; 1'b0: HSRX off to standby in low power state
  input RESET;              //Reset signal: 1'b1: reset all; 
  
  input D0LN_HSRX_DREN,  D1LN_HSRX_DREN, D2LN_HSRX_DREN, D3LN_HSRX_DREN;//Data Lane HSRX driver enabled
  
  input DESKEW_BY,DESKEW_EN_OEDGE;
  input [5:0] DESKEW_HALF_OPENING;
  
  input [2:0] DESKEW_LNSEL; //selection of lane to config delay overwrite value and make lane in deskew delay overwrite mode
  
  input [1:0] DESKEW_LSB_MODE;
  input [2:0] DESKEW_M;//counter threathold for confirming edge
  input [12:0] DESKEW_MTH;   //counter threathold for searching one edge
  input [6:0] DESKEW_MSET;
  input DESKEW_OCLKEDG_EN;
  input [6:0] DESKEW_OWVAL;
  input DESKEW_REQ;         //deskew function request to all data lanes
  
  input DO_LPTX0_N, DO_LPTX0_P, DO_LPTX1_N, DO_LPTX1_P, DO_LPTX2_N, DO_LPTX2_P, DO_LPTX3_N, DO_LPTX3_P;// Complement/True Pad LPTX output
  input DO_LPTXCK_N, DO_LPTXCK_P;
  input DRST_N;             //digital reset, active low
  
  input [2:0] EQCS_LANE0,EQCS_LANE1,EQCS_LANE2,EQCS_LANE3,EQCS_CK;
  input [2:0] EQRS_LANE0,EQRS_LANE1,EQRS_LANE2,EQRS_LANE3,EQRS_CK;
  
  input HS_8BIT_MODE;       //Selection of data width to Fabric
  
  input HSRX_DLYDIR_LANE0, HSRX_DLYDIR_LANE1,HSRX_DLYDIR_LANE2,HSRX_DLYDIR_LANE3,HSRX_DLYDIR_CK;
  input HSRX_DLYLDN_LANE0, HSRX_DLYLDN_LANE1,HSRX_DLYLDN_LANE2,HSRX_DLYLDN_LANE3,HSRX_DLYLDN_CK;
  input HSRX_DLYMV_LANE0, HSRX_DLYMV_LANE1,HSRX_DLYMV_LANE2,HSRX_DLYMV_LANE3,HSRX_DLYMV_CK;
  
  input HSRX_EN_CK;         //CK Lane: 1'b1 HSRX enabled
  input HSRX_ODTEN_CK, HSRX_ODTEN_D0,  HSRX_ODTEN_D1, HSRX_ODTEN_D2, HSRX_ODTEN_D3;//CK/Data Lane HSRX ODT enabled
  input LALIGN_EN;          //lane aligner enable
  input LPRX_EN_CK, LPRX_EN_D0, LPRX_EN_D1, LPRX_EN_D2, LPRX_EN_D3;
  input LPTX_EN_CK, LPTX_EN_D0, LPTX_EN_D1, LPTX_EN_D2, LPTX_EN_D3;//1'b1 LPTX enabled
  input ONE_BYTE0_MATCH;    //byte count match in word aligner
  input RX_CLK_1X;          //1X clock from fabric, max 93.75MHz@1.5Gbps
  input RX_INVERT;          //data polarity selection
  input WALIGN_BY;          //word aligner bypass
  input WALIGN_DVLD;
  input WORD_LENDIAN;       //data little/big endian of dual word(16bit, 8bit/word). Not used in 8bit data output mode
  
  
  parameter ALIGN_BYTE = 8'b10111000;//KEY for word aligner and lane aligner
  parameter EN_CLKB1X = 1'b1;//1'b1: enable CLK2X to Fabric
  parameter EQ_ADPSEL_LANE0 = 1'b0;
  parameter EQ_ADPSEL_LANE1 = 1'b0;
  parameter EQ_ADPSEL_LANE2 = 1'b0;
  parameter EQ_ADPSEL_LANE3 = 1'b0;
  parameter EQ_ADPSEL_CK = 1'b0;
  parameter EQ_CS_LANE0 = 3'b100;
  parameter EQ_CS_LANE1 = 3'b100;
  parameter EQ_CS_LANE2 = 3'b100;
  parameter EQ_CS_LANE3 = 3'b100;
  parameter EQ_CS_CK = 3'b100;
  
  parameter EQ_PBIAS_LANE0 = 4'b0100;//Equalizer source current setting: 4'b0000(80uA)~4'b0111(360uA), 40uA/step
  parameter EQ_PBIAS_LANE1 = 4'b0100;//Equalizer source current setting: 4'b0000(80uA)~4'b0111(360uA), 40uA/step
  parameter EQ_PBIAS_LANE2 = 4'b0100;//Equalizer source current setting: 4'b0000(80uA)~4'b0111(360uA), 40uA/step
  parameter EQ_PBIAS_LANE3 = 4'b0100;//Equalizer source current setting: 4'b0000(80uA)~4'b0111(360uA), 40uA/step
  parameter EQ_PBIAS_CK = 4'b0100;//Equalizer source current setting: 4'b0000(80uA)~4'b0111(360uA), 40uA/step
  
  parameter EQ_RS_LANE0 = 3'b100;
  parameter EQ_RS_LANE1 = 3'b100;
  parameter EQ_RS_LANE2 = 3'b100;
  parameter EQ_RS_LANE3 = 3'b100;
  parameter EQ_RS_CK = 3'b100;
  
  parameter EQ_ZLD_LANE0 = 4'b1000;//Preamplifier Resistive Load Setting: 4'b0000 3K; 4'b0001 2.5K; 4'b0011 2K; 4'b0111 1.5K; 4'b1111 1K
  parameter EQ_ZLD_LANE1 = 4'b1000;//Preamplifier Resistive Load Setting: 4'b0000 3K; 4'b0001 2.5K; 4'b0011 2K; 4'b0111 1.5K; 4'b1111 1K
  parameter EQ_ZLD_LANE2 = 4'b1000;//Preamplifier Resistive Load Setting: 4'b0000 3K; 4'b0001 2.5K; 4'b0011 2K; 4'b0111 1.5K; 4'b1111 1K
  parameter EQ_ZLD_LANE3 = 4'b1000;//Preamplifier Resistive Load Setting: 4'b0000 3K; 4'b0001 2.5K; 4'b0011 2K; 4'b0111 1.5K; 4'b1111 1K
  parameter EQ_ZLD_CK = 4'b1000;//Preamplifier Resistive Load Setting: 4'b0000 3K; 4'b0001 2.5K; 4'b0011 2K; 4'b0111 1.5K; 4'b1111 1K
  
  parameter HIGH_BW_LANE0 = 1'b1;
  parameter HIGH_BW_LANE1 = 1'b1;
  parameter HIGH_BW_LANE2 = 1'b1;
  parameter HIGH_BW_LANE3 = 1'b1;
  parameter HIGH_BW_CK = 1'b1;
  
  parameter HSRX_DLYCTL_CK = 7'b0000000;
  parameter HSRX_DLYCTL_LANE0 = 7'b0000000;
  parameter HSRX_DLYCTL_LANE1 = 7'b0000000;
  parameter HSRX_DLYCTL_LANE2 = 7'b0000000;
  parameter HSRX_DLYCTL_LANE3 = 7'b0000000;
  
  parameter HSRX_DLY_SEL = 1'b0;
  
  parameter HSRX_DUTY_LANE0 = 4'b1000;
  parameter HSRX_DUTY_LANE1 = 4'b1000;
  parameter HSRX_DUTY_LANE2 = 4'b1000;
  parameter HSRX_DUTY_LANE3 = 4'b1000;
  parameter HSRX_DUTY_CK = 4'b1000;
  
  parameter HSRX_EN = 1'b1;
  
  parameter HSRX_EQ_EN_LANE0 = 1'b1;//Equalizer Enable of HSRX: 1'b0 disable; 1'b1 enable
  parameter HSRX_EQ_EN_LANE1 = 1'b1;//Equalizer Enable of HSRX: 1'b0 disable; 1'b1 enable
  parameter HSRX_EQ_EN_LANE2 = 1'b1;//Equalizer Enable of HSRX: 1'b0 disable; 1'b1 enable
  parameter HSRX_EQ_EN_LANE3 = 1'b1;//Equalizer Enable of HSRX: 1'b0 disable; 1'b1 enable
  parameter HSRX_EQ_EN_CK = 1'b1;//Equalizer Enable of HSRX: 1'b0 disable; 1'b1 enable
  
  parameter HSRX_IBIAS = 4'b0011;//HSRX current bias setting: default 4'b0011, available(4'b0000~4'b0111) 2uA/step
  
  parameter HSRX_IMARG_EN = 1'b1;
  
  parameter MIPI_LANE0_EN = 1'b0;// 1'b1, Lane0 on; 
  parameter MIPI_LANE1_EN = 1'b0;// 1'b1, Lane1 on; 
  parameter MIPI_LANE2_EN = 1'b0;// 1'b1, Lane2 on;  
  parameter MIPI_LANE3_EN = 1'b0;// 1'b1, Lane3 on;  
  parameter MIPI_CK_EN = 1'b1;//CK Lane Select: 1'b1 CK Lane on
  
  parameter HSRX_ODT_EN = 1'b1;//HSRX ODT enable for CIB control: 1'b1 enable
  parameter HSRX_ODT_TST = 4'b0000;
  parameter HSRX_ODT_TST_CK = 1'b0;
  
  parameter HSRX_STOP_EN = 1'b0;//Enable HSRX clock stop sync: 1'b1: enable
  parameter HSRX_TST = 4'b0000;
  parameter HSRX_TST_CK = 1'b0;
  
  parameter HSRX_WAIT4EDGE = 1'b0;
  parameter HYST_NCTL = 2'b01;//LPRX hysterisis control of VTH_N: 2'b00~2'b11 minimum~maximum
  parameter HYST_PCTL = 2'b01;//LPRX hysterisis control for VTH_P: 2'b00~2'b11 minimum~maximum
  
  parameter LOW_LPRX_VTH = 1'b0;
  
  parameter LPRX_EN = 1'b1;//1'b1: LPRX enabled for CIB control
  parameter LPRX_TST = 4'b0000;
  parameter LPRX_TST_CK = 1'b0;
  
  parameter LPTX_EN = 1'b1;//1'b1: LPTX enabled for CIB control
  parameter LPTX_SW_LANE0 = 3'b100;
  parameter LPTX_SW_LANE1 = 3'b100;
  parameter LPTX_SW_LANE2 = 3'b100;
  parameter LPTX_SW_LANE3 = 3'b100;
  parameter LPTX_SW_CK = 3'b100;
  parameter LPTX_TST = 4'b0000;
  parameter LPTX_TST_CK = 1'b0;
  
  parameter MIPI_DIS_N = 1'b1;
  
  parameter PGA_BIAS_LANE0 =  4'b1000;
  parameter PGA_BIAS_LANE1 =  4'b1000;
  parameter PGA_BIAS_LANE2 =  4'b1000;
  parameter PGA_BIAS_LANE3 =  4'b1000;
  parameter PGA_BIAS_CK =  4'b1000;
  
  parameter PGA_GAIN_LANE0 =  4'b1000;
  parameter PGA_GAIN_LANE1 =  4'b1000;
  parameter PGA_GAIN_LANE2 =  4'b1000;
  parameter PGA_GAIN_LANE3 =  4'b1000;
  parameter PGA_GAIN_CK =  4'b1000;
  
  parameter RX_CLK1X_SYNC_SEL = 1'b0;
  
  parameter RX_ODT_TRIM_LANE0 = 4'b0111;//100ohm ODT trimming, ~4ohm/step
  parameter RX_ODT_TRIM_LANE1 = 4'b0111;//100ohm ODT trimming, ~4ohm/step
  parameter RX_ODT_TRIM_LANE2 = 4'b0111;//100ohm ODT trimming, ~4ohm/step
  parameter RX_ODT_TRIM_LANE3 = 4'b0111;//100ohm ODT trimming, ~4ohm/step
  parameter RX_ODT_TRIM_CK = 4'b0111;//100ohm ODT trimming, ~4ohm/step
  
  parameter STP_UNIT = 2'b00;
  
  parameter SYNC_CLK_SEL = 1'b1;//select clock source for HS lane output data:0,select fabric input clock rx_clk_1x; 1,select output clock RX_CLK_O
  
  parameter WALIGN_DVLD_SRC_SEL = 1'b0;

  supply1 vcc;
  supply0 vss;
  wire [4:0] gw5at_5bkWwpL3, gw5at_Zuu_rpMv, gw5at_4RySYtJH, gw5at_J21CXtOf, gw5at_xJyWK8aw;

  reg gsrn;
  initial begin
    gsrn=0;
    #0;
    gsrn=1;
  end

  //dphy_top pm(
  gw5at_hyXGXwTLHx_Kidvkyr1wqQ pm(
    gw5at_5bkWwpL3, D0LN_DESKEW_DONE, D0LN_HSRXD, D0LN_HSRXD_VLD, gw5at_Zuu_rpMv, D1LN_DESKEW_DONE, D1LN_HSRXD, 
    D1LN_HSRXD_VLD, gw5at_4RySYtJH, D2LN_DESKEW_DONE, D2LN_HSRXD, D2LN_HSRXD_VLD, gw5at_J21CXtOf, D3LN_DESKEW_DONE, 
    D3LN_HSRXD, D3LN_HSRXD_VLD, gw5at_xJyWK8aw, DESKEW_ERROR, DI_LPRX0_N, DI_LPRX0_P, DI_LPRX1_N, DI_LPRX1_P, 
    DI_LPRX2_N, DI_LPRX2_P, DI_LPRX3_N, DI_LPRX3_P, DI_LPRXCK_N, DI_LPRXCK_P, RX_CLK_O, CK_N, CK_P, RX0_N, RX0_P, 
    RX1_N, RX1_P, RX2_N, RX2_P, RX3_N, RX3_P, vcc, vcc, vcc, vcc, vcc, vss, BYTE_LENDIAN, FIFO_RD_STD, HSRX_STOP, 1'b0,
    4'b0, 4'b0, PWRON, RESET, 5'b0, D0LN_HSRX_DREN, 5'b0, D1LN_HSRX_DREN, 5'b0, D2LN_HSRX_DREN, 5'b0, D3LN_HSRX_DREN, 
    5'b0, DESKEW_BY, DESKEW_EN_OEDGE, DESKEW_HALF_OPENING, DESKEW_LNSEL, DESKEW_LSB_MODE, DESKEW_M, DESKEW_MTH, 
    DESKEW_MSET, DESKEW_OCLKEDG_EN, DESKEW_OWVAL, DESKEW_REQ, DO_LPTX0_N, DO_LPTX0_P, DO_LPTX1_N, DO_LPTX1_P, 
    DO_LPTX2_N, DO_LPTX2_P, DO_LPTX3_N, DO_LPTX3_P, DO_LPTXCK_N, DO_LPTXCK_P, DRST_N, EQCS_LANE0, EQCS_LANE1, 
    EQCS_LANE2, EQCS_LANE3, EQCS_CK, EQRS_LANE0, EQRS_LANE1, EQRS_LANE2, EQRS_LANE3, EQRS_CK, gsrn, HS_8BIT_MODE,
    HSRX_DLYDIR_LANE0, HSRX_DLYDIR_LANE1, HSRX_DLYDIR_LANE2, HSRX_DLYDIR_LANE3, HSRX_DLYDIR_CK, HSRX_DLYLDN_LANE0,
    HSRX_DLYLDN_LANE1, HSRX_DLYLDN_LANE2, HSRX_DLYLDN_LANE3, HSRX_DLYLDN_CK, HSRX_DLYMV_LANE0, HSRX_DLYMV_LANE1, 
    HSRX_DLYMV_LANE2, HSRX_DLYMV_LANE3, HSRX_DLYMV_CK, HSRX_EN_CK, HSRX_ODTEN_CK, HSRX_ODTEN_D0, HSRX_ODTEN_D1, 
    HSRX_ODTEN_D2, HSRX_ODTEN_D3, LALIGN_EN, LPRX_EN_CK, LPRX_EN_D0, LPRX_EN_D1, LPRX_EN_D2, LPRX_EN_D3, LPTX_EN_CK,
    LPTX_EN_D0, LPTX_EN_D1, LPTX_EN_D2, LPTX_EN_D3, ALIGN_BYTE, EN_CLKB1X, EQ_ADPSEL_LANE0, EQ_ADPSEL_LANE1, 
    EQ_ADPSEL_LANE2, EQ_ADPSEL_LANE3, EQ_ADPSEL_CK, EQ_CS_LANE0, EQ_CS_LANE1, EQ_CS_LANE2, EQ_CS_LANE3, EQ_CS_CK, 
    EQ_PBIAS_LANE0, EQ_PBIAS_LANE1, EQ_PBIAS_LANE2, EQ_PBIAS_LANE3, EQ_PBIAS_CK, EQ_RS_LANE0, EQ_RS_LANE1, EQ_RS_LANE2,
    EQ_RS_LANE3, EQ_RS_CK, EQ_ZLD_LANE0, EQ_ZLD_LANE1, EQ_ZLD_LANE2, EQ_ZLD_LANE3, EQ_ZLD_CK, HIGH_BW_LANE0,
    HIGH_BW_LANE1, HIGH_BW_LANE2, HIGH_BW_LANE3, HIGH_BW_CK, HSRX_DLYCTL_CK, HSRX_DLYCTL_LANE0, HSRX_DLYCTL_LANE1, 
    HSRX_DLYCTL_LANE2, HSRX_DLYCTL_LANE3, HSRX_DLY_SEL, HSRX_DUTY_LANE0, HSRX_DUTY_LANE1, HSRX_DUTY_LANE2, 
    HSRX_DUTY_LANE3, HSRX_DUTY_CK, HSRX_EN, HSRX_EQ_EN_LANE0, HSRX_EQ_EN_LANE1, HSRX_EQ_EN_LANE2, HSRX_EQ_EN_LANE3,
    HSRX_EQ_EN_CK, HSRX_IBIAS, HSRX_IMARG_EN, {MIPI_LANE3_EN, MIPI_LANE2_EN, MIPI_LANE1_EN, MIPI_LANE0_EN}, MIPI_CK_EN,
    HSRX_ODT_EN, HSRX_ODT_TST, HSRX_ODT_TST_CK, 4'b0, HSRX_STOP_EN, HSRX_TST, HSRX_TST_CK, HSRX_WAIT4EDGE, HYST_NCTL,
    HYST_PCTL, LOW_LPRX_VTH, 4'b0, 1'b0, LPRX_EN, LPRX_TST, LPRX_TST_CK, LPTX_EN, LPTX_SW_LANE0, LPTX_SW_LANE1, 
    LPTX_SW_LANE2, LPTX_SW_LANE3, LPTX_SW_CK, LPTX_TST, LPTX_TST_CK, MIPI_DIS_N, PGA_BIAS_LANE0, PGA_BIAS_LANE1,
    PGA_BIAS_LANE2, PGA_BIAS_LANE3, PGA_BIAS_CK, PGA_GAIN_LANE0, PGA_GAIN_LANE1, PGA_GAIN_LANE2, PGA_GAIN_LANE3, 
    PGA_GAIN_CK, RX_CLK1X_SYNC_SEL, RX_ODT_TRIM_LANE0, RX_ODT_TRIM_LANE1, RX_ODT_TRIM_LANE2, RX_ODT_TRIM_LANE3,
    RX_ODT_TRIM_CK, STP_UNIT, SYNC_CLK_SEL, 2'b0, WALIGN_DVLD_SRC_SEL, ONE_BYTE0_MATCH, 1'b1, RX_CLK_1X, RX_INVERT, 
    vcc, WALIGN_BY, WALIGN_DVLD, WORD_LENDIAN
  );

endmodule

